// MORSE SEQUENCER DESIGNED BY DR. EMIT SNAKE-BEINGS WWW.SNAKEBEINGS.ORG 
// PORT CHALMERS ARTSCIENCE RESIDENCY MARCH 2018


//BEAWARE GLOBALS USE MORE DYNAMIC MEMORY THAN LOCALS!!
//>>>>>>>>>>>>GLOBAL VARIABLES: TIMINGS, GAPS AND MIDI DATA ARRAYS
unsigned long OnTime[10] = {0,  0, 0,  0,  0, 0,  0,  0};//records the ON times
unsigned long OffTime[10] = {0,  0, 0,  0,  0, 0,  0,  0};//records the ON times
unsigned long GapStart[10] = {0,  0, 0,  0,  0, 0,  0,  0};//records the gaps
unsigned long GapEnd[10] = {0,  0, 0,  0,  0, 0,  0,  0};//records the gaps

//record the MIDI DATA 8 note polyphonic for playback
unsigned long MidiData[10][8] = 
{
  {0,  0, 0,  0,  0, 0,  0,  0},{0,  0, 0,  0,  0, 0,  0,  0},
  {0,  0, 0,  0,  0, 0,  0,  0},{0,  0, 0,  0,  0, 0,  0,  0},
  {0,  0, 0,  0,  0, 0,  0,  0},{0,  0, 0,  0,  0, 0,  0,  0},
  {0,  0, 0,  0,  0, 0,  0,  0},{0,  0, 0,  0,  0, 0,  0,  0}
};
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>


int sequenceLoop = 0;
unsigned long currentMillis;
unsigned long previousMillis;
int ledState = LOW;  // for the flipflop blue led
unsigned Keyon = "no";
int sequenceA0 = 0;
int MidiChannelA1 = 0; //midi channel selector (was called )
int FrequencyA2 = 0; 
unsigned StartSeq = "no"; //this signals the first on button to prevent off state recording gap data           
       int morse = 10; //pin for switch
       int pin1 = 5; //set the led pin outputs BLUE
       int pin2 = 6; //GREEN

       //>>>>>>>>>>>>>>>>>>>>
//int startTime = 0;
//int stopTime = 0 ;
//int intervalBlue =0;
//int ledState; //on/off flipflop

 int buttonState = 0; //see if button is on


 //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
void setup() {
  // put your setup code here, to run once:
 
        // initialize serial:
Serial.begin(9600);
       pinMode(pin1, OUTPUT);
      pinMode(pin2, OUTPUT);
        pinMode(morse, INPUT);
       // pinMode(A0, INPUT);
      //  pinMode(A1, INPUT);
       // pinMode(A2, INPUT);
        //TURN OFF BLUE LIGHT
digitalWrite(pin1, HIGH); //OFF
   //TURN OFF GREEN LIGHT
digitalWrite(pin2, HIGH); //OFF
}

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



void sequencePlay()
{
for (int play = 0; play < sequenceA0; play++) {
   
    int interval = OnTime[play];
    Serial.print(interval);
    Serial.print("\t at line ");
Serial.print(play);
Serial.println(">>>>>>");

 unsigned long playMillis = millis();

  if (playMillis - previousMillis >= interval) {
    // save the last time you blinked the LED
    previousMillis = currentMillis;}

    // if the LED is off turn it on and vice-versa:
    if (ledState == LOW) {
      ledState = HIGH;
    } else {
      ledState = LOW;
    }
    // set the LED with the ledState of the variable:
    digitalWrite(pin1, ledState);
  }}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>LOOP STARTS HERE
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 void loop()
    {
  //save value of analogue dials to see if they change
int seqSaved = sequenceA0;
int MCSaved =  MidiChannelA1;

    //READ ALL THE DIALS AT START
sequenceA0 = analogRead(A0); //looplength
MidiChannelA1 = analogRead(A1); 
FrequencyA2 = analogRead(A2); 

  //MAP THE DIALS TO USEFUL RANGES AND INVERT THE SCALE
sequenceA0 = map(sequenceA0,1023, 0, 0, 10); // UP TO TEN STEPS IN A SEQUENCE 
MidiChannelA1 = map(MidiChannelA1,1023, 0, 0, 8);// 8 MIDI POLYPHONIC
FrequencyA2 = map(FrequencyA2,1023, 0, 0, 8888); //PITCH SHIFT OF EACH NOTE IN SEQUENCE

if(seqSaved != sequenceA0)//print sequence Analogue control if number changes
{
Serial.print("\t SEQUENCE = ");
Serial.print(sequenceA0);
Serial.println(">>>>>>");
}
if(MCSaved != MidiChannelA1)//print sequence Analogue control if number changes
{
Serial.print("\t MIDI CHANNEL = ");
Serial.print(MidiChannelA1);
Serial.println(">>>>>>");
}

 //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
 // read the buttonState of the Morse Key:
    buttonState = digitalRead(morse);

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>MORSE ON
//IF MORSE KEY PRESSED
  if (buttonState == LOW and Keyon == "no") {
     // turn GREEN LED on:
     digitalWrite(pin2, LOW);//ON
     //check to see if its the very start of sequence
     StartSeq = "yes";//signal first start of data
     Keyon = "yes"; //latches key on just once

//RECORD THE START OF THE ON TIME >> MUST BE A SIMPLER WAY TO DO THIS?????
currentMillis = millis();
OnTime[sequenceLoop] = currentMillis;


//THIS DETECTS THE FIRST RUN OF THE SEQUENCE =ITS NOT WORKING RIGHT!!
if(OffTime[sequenceLoop] != 0){
currentMillis = millis();
GapEnd[sequenceLoop] = currentMillis;
  }
 }//END MORSE ON


//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> START MORSE OFF
//IF MORSEKEY RELEASED
  if (buttonState == HIGH and Keyon == "yes" and StartSeq == "yes") {
      Keyon = "no"; //latches key on just once
 currentMillis = millis();
OffTime[sequenceLoop] = currentMillis;

   sequenceLoop++;
     // turn GREEN LED OFF:
     digitalWrite(pin2, HIGH);//OFF
     
//THIS IS FOR THE VERY FIRST LOOP AFTER START UP -NOT SURE WHY?
    if(OnTime[0] != 0){
      currentMillis = millis();
GapStart[sequenceLoop] = currentMillis;
Serial.print(sequenceLoop);
  }
  
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>END SEQUENCE START LOOP ON MIDI CHANNEL TWO
  //WHEN THE SEQUENCE REACHES ITS END
 if(sequenceLoop == sequenceA0)
 {
 OnTime[0]=0;

   for (int play = 0; play < sequenceA0; play++) {
    int interval = (OffTime[play] - OnTime[play]);
    int gap = (GapEnd[play]- GapStart[play] ); 
   
 //DO SOMETHING WITH THE COLLECTED INFO   
    Serial.print("\t gap duration = ");
     Serial.print(gap);
    Serial.print("\t Note duration = ");
    Serial.print(interval);
    Serial.print("\t at line ");
    Serial.print(play);
    Serial.println(">>>>>>");

//FORMATT THE STRINGS FOR MIDI SENDING AND SAVE THEM INTO THE ARRAY  
//int note = pitchshift;
int noteon = interval;
int noteoff = gap;
//MidiData[play][MidiChannelA1] = ("42," + interval..................... 
    
    //RESET LOOP TO START
 sequenceLoop =0;
 }  
  }
   }
    }//>>>>>>>>>>>>>>END LOOP
  
 


  



/// MORSE SEQUENCER DESIGNED BY DR. EMIT SNAKE-BEINGS WWW.SNAKEBEINGS.ORG 
// PORT CHALMERS ARTSCIENCE RESIDENCY MARCH 2018
