
// Example 4 - Receive a number as text and convert it to an int

const byte numChars = 32;
char receivedChars[numChars];   // an array to store the received data

boolean newData = false;

int dataNumber = 0; 

#include <MozziGuts.h>
#include <Oscil.h> // oscillator template
#include <tables/sin2048_int8.h> // sine table for oscillator

// use: Oscil <table_size, update_rate> oscilName (wavetable), look in .h file of table #included above
Oscil <SIN2048_NUM_CELLS, AUDIO_RATE> aSin(SIN2048_DATA);
int frequencySine = 22; //actual sine fre
// use #define for CONTROL_RATE, not a constant
#define CONTROL_RATE 64 // powers of 2 please


// just add more primes to the prime table for larger search
// byte data type to save memory - use a larger datatype with prime table entries above 255 :)
byte primes[] = {
  2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101,
  102, 107, 109, 113, 127, 131,  137 , 139, 149, 151, 157, 163, 167, 173,  179, 181, 191, 193, 197,
  199, 211, 223, 227, 229, 233, 239, 241, 251
};

// if you change the datatype of primes array to int, change next line to
// "const int TopPrimeIndex = (sizeof(primes)/2) - 1;"

const unsigned int TopPrimeIndex = sizeof(primes) - 1;
const unsigned long TopPrimeSquared = (long)primes[TopPrimeIndex] * (long)primes[TopPrimeIndex];
int  freqency =0;
#include "LedControl.h"

//  MAX72XX (DIN,CLK,CS)

LedControl lc = LedControl(4, 2, 3, 1);

/* we always wait a bit between updates of the display */
int delaytime = 0;
long previousMillis = millis();
long looplength = 10000000;
int interval = 300;//tempo of number selection
int stopclock = 0;
int primeFlag;
long randNUmMAX = 495; //limits of prime selected randomly
long randNUmMAX2 = 777; //limits of prime selected randomly
long randNUmMAX3 = 250; //limits of prime selected randomly bass notes
long randNUmMAX4 = 1700; //
int noteSeq;//array count for note storage
void setup() {
startMozzi(CONTROL_RATE); // set a control rate of 64 (powers of 2 please)
  aSin.setFreq(440); // set the frequency
Serial.begin(9600);
  lc.shutdown(0, false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0, 8);
  /* and clear the display */
  lc.clearDisplay(0);
}





void primesSel4(long startNum) {
  long x = startNum;
  // for (long x = startNum; x < TopPrimeSquared; x+=2){// skips even numbers, including 2, which is prime, but it makes algorithm tad faster

  while (x < TopPrimeSquared) {
    for (long j = 0; j < TopPrimeIndex; j++) {
      primeFlag = true;

      if (x == primes[j]) break;

      if (x % primes[j] == 0) {    // if the test number modolo (next number from prime table) == 0
        primeFlag = false;
        // Serial.println(x);//  then test number is not prime, bailout and check the next number
        break;

      }

    }
    if (primeFlag == true) { // found a prime - print it

      stopclock = 0;
      // Serial.print("OOOOOOOOO");
      // Serial.println(x);
      long i = x;
      //stop the search
      x = TopPrimeSquared;





      int di1 = i / 1 % 10;
      lc.setDigit(0, 0, (di1), false);
      int di10 = i / 10 % 10;
      lc.setDigit(0, 1, (di10), false);
      int di100 = i / 100 % 10;
      lc.setDigit(0, 2, (di100), false);
      int di1000 = i / 1000 % 10;
      lc.setDigit(0, 3, (di1000), false);
      int di10000 = i / 10000 % 10;
      lc.setDigit(0, 4, (di10000), false);
      int di100000 = i / 100000 % 10;
      lc.setDigit(0, 5, (di100000), false);
      int di1000000 = i / 1000000 % 10;
      lc.setDigit(0, 6, (di1000000), false);
      int di10000000 = i / 10000000 % 10;
      lc.setDigit(0, 7, (di10000000), false);
//Serial.println("init");
Serial.println(i, DEC);





freqency = i;


//int freq = serial.read();
      //sound test
frequencySine =  freqency;
      
     // tone(5,  (freqency));
      //int tonelen = random(1000, 3500);
      //delay(tonelen);
     // noTone(5);

    }  x++;


  }

}


void updateControl(){
  // put changing controls in here
  aSin.setFreq(frequencySine); // set the frequency
}


int updateAudio(){
  return aSin.next(); // return an int signal centred around 0
}

void loop()                     // run over and over again
{
  audioHook(); // required here

  // STOP THE CLOCK
  if ((millis() - previousMillis > interval) and stopclock == 0) {
    // STOP CLOCK DISPLAY
    stopclock = 1;
    previousMillis = millis();

 
int i = random(0,3);
int select = i;
    //use this random range selector to add variation into the
    //sound by choosing different ranges
    //int select = random(0,2);

    //play the sequence below of selecting the range to add some order to the chaos
    int noteSeqArray[] = {0, 1, 0, 3, 2, 1, 2, 0, 2, 0, 3, 0, 2};
    select = noteSeqArray[noteSeq];
    
//could use case select here to limit the ranges
    if (select == 0) {
      i = random(2, randNUmMAX);
    }
    if (select == 1) {
      i = random(2, randNUmMAX2);
    }
    if (select == 2) {
      i = random(2, randNUmMAX3);
    }
    if (select == 3) {
      i = random(2, randNUmMAX4);
    }

    // add a random interval tempo optional experiment
    //interval = random(1, 500);

    //send random start point / range to note generator and display function
    primesSel4(i);
    noteSeq++;

    
    if (noteSeq > 4) {
      noteSeq = 0;
    }
  }
}
